(function($, doc) {
    var MIN_SOUND_TIME = 800;
    var id = window.location.search.substring(4);
    
    Tools.init({
        gestureConfig: {
            tap: true, //默认为true
            doubletap: true, //默认为false
            longtap: true, //默认为false
            swipe: true, //默认为true
            drag: true, //默认为true
            hold: true, //默认为false，不监听
            release: true //默认为false，不监听
        }
    });
    template.config('escape', false);
    //$.plusReady=function(fn){fn();};
    $.plusReady(function() {
        // 列表页webview对象
        var groupIndexView = plus.webview.getWebviewById('page/group/index.html');
        var teacher = Tools.getUser();
        var currentWebView = plus.webview.currentWebview();
        var record = JSON.parse(plus.storage.getItem('record' + id)) || [];
        
        
        document.getElementById('title').innerHTML = currentWebView.title;
        
        // 修改群聊名称 
        window.addEventListener('updateGroupName', function (e) {
            document.getElementById('title').innerHTML = e.detail.groupName;
        })
        
        // 清除聊天记录 
        window.addEventListener('clearLog', function () {
            record = [];
            bindMsgList();
        })
        
        // 接收新通知消息
        window.addEventListener('sendMessage', function (e) {
            if(e.detail.talkId != id) return ;
            pushMsg(e.detail.message);            
        })
        
        
        
        
        // 打开群聊用户列表
        $(document).on('tap', '#showGroupUsers', function () {
            Tools.openWindow({
                url: 'users.html',
                id: 'showGroupUsers',
                title: '用户列表',
                extras: {
                    talkId: id
                }
            });
        })
        
        plus.webview.currentWebview().setStyle({
            softinputMode: "adjustResize"
        });
        // 显示键盘
        var showKeyboard = function() {
            if($.os.ios) {
                var webView = plus.webview.currentWebview().nativeInstanceObject();
                webView.plusCallMethod({
                    "setKeyboardDisplayRequiresUserAction": false
                });
            } else {
                var Context = plus.android.importClass("android.content.Context");
                var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
                var main = plus.android.runtimeMainActivity();
                var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
                //var view = ((ViewGroup)main.findViewById(android.R.id.content)).getChildAt(0);
                imm.showSoftInput(main.getWindow().getDecorView(), InputMethodManager.SHOW_IMPLICIT);
                //alert("ll");
            }
        };
//      var record = [{
//          sender: 'zs',
//          type: 'text',
//          content: 'Hi，我是 MUI 小管家！'
//      }];

        var pushMsg = function (msg) {
            mui.fire(groupIndexView, 'updateLastRecord', {
                id: id,
                record: msg
            })
            record.push(msg);
            bindMsgList();
        }


        var sendMessage = function (msg) {
            pushMsg(msg);
            
            var options = mui.extend({}, msg, {
                'teacher.id': teacher.id,
            })            
            
            var task = plus.uploader.createUpload(SERVERURL + 'talk.send.action', {
                method: 'POST',
                blocksize: 204800,
                priority: 100
            }, function(t, status) {
                Tools.log(t)
                Tools.waiting();
                if(status == 200) {                                            
                    var data = JSON.parse(t.responseText);
                    Tools.log(data)                    
                    if(data.result.error) return mui.toast(data.result.info);                                                                                   
                } else {
                    mui.toast('发送失败！');
                }
            });
            
            for( var key in options) {
                if(typeof options[key] !== 'object')
                    task.addData(key, options[key].toString());
            }
            
            // 添加文件
            if (options.type !== 'text'){
                task.addFile(options.path, {
                    key: 'file'
                });
            }                
            task.start();
        } 

        
        var ui = {
            body: doc.querySelector('body'),
            footer: doc.querySelector('footer'),
            footerRight: doc.querySelector('.footer-right'),
            footerLeft: doc.querySelector('.footer-left'),
            btnMsgType: doc.querySelector('#msg-type'),
            boxMsgText: doc.querySelector('#msg-text'),
            boxMsgSound: doc.querySelector('#msg-sound'),
            btnMsgImage: doc.querySelector('#msg-image'),
            areaMsgList: doc.querySelector('#msg-list'),
            boxSoundAlert: doc.querySelector('#sound-alert'),
            h: doc.querySelector('#h'),
            content: doc.querySelector('.mui-content')
        };
        ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
        //alert(ui.boxMsgTe3xt.offsetWidth );
        var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight;
        
        var playSound = function (playState, msgContent) {
            player = plus.audio.createPlayer(msgContent);
            
            playState.innerText = '正在播放';
            console.log('asdfasdf')
            player.play(function() {
                console.log('play')
                playState.innerText = '点击播放';
            }, function(e) {
                playState.innerText = '点击播放';
            });
        }
        var msgItemTap = function(msgItem, event) {
            var msgType = msgItem.getAttribute('msg-type');
            var msgContent = msgItem.getAttribute('msg-content')
            var playState = msgItem.querySelector('.play-state');
            if(msgType == 'sound') {
                if(plus.os.name === 'iOS' && msgContent.indexOf('http') == 0) {
                    playState.innerText = '正在加载';
                    // ios需要将文件下载到本地后才能播放
                    var dtask = plus.downloader.createDownload(msgContent, {
                        filename: '_doc/round/', 
                    }, function (down, status) {
                        if(status == 200) {
                            playSound(playState, down.filename);
                        } else {
                            playState.innerText = '加载失败，请重试！';
                        }
                    })
                    dtask.start();
                } else {
                    playSound(playState, msgContent);  
                }

            }
        };
        
        var imageViewer = new $.ImageViewer('.msg-content-image', {
            dbl: false
        });
        var bindMsgList = function() {
            //绑定数据:
            /*tp.bind({
                template: 'msg-template',
                element: 'msg-list',
                model: record
            });*/
            ui.areaMsgList.innerHTML = template('msg-template', {
                "record": record,
                "self": teacher.teacherName,
                "teacher": teacher,
                "showDate": showDate,
                "server": SERVERURL
            });
            // 保存聊天记录到本地数据
            plus.storage.setItem('record' + id, JSON.stringify(record));
            
            var msgItems = ui.areaMsgList.querySelectorAll('.msg-content');
            [].forEach.call(msgItems, function(item, index) {
                item.addEventListener('tap', function(event) {
                    msgItemTap(item, event);
                }, false); 
            });
            imageViewer.findAllImage();
            ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
        };
        bindMsgList();
        window.addEventListener('resize', function() {
            ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
        }, false);
        // 发送消息
        var send = function(msg) {
            msg.date = Date.now();
            msg.sender = {
                name: teacher.teacherName,
                id: 0
            }
            msg.id = id;
            console.log(JSON.stringify(msg))
            sendMessage(msg);
//          bindMsgList();
//          sendMessage(msg);
        };
        
        
        var toRobot = function(info) {
            var apiUrl = 'http://www.tuling123.com/openapi/api';
            $.getJSON(apiUrl, {
                "key": 'acfbca724ea1b5db96d2eef88ce677dc',
                "info": info,
                "userid": plus.device.uuid
            }, function(data) {
                //alert(JSON.stringify(data));
                sendMessage({
                    sender: {
                        name: 'zs',
                        id: 1
                    },
                    type: 'text',
                    date: Date.now(),
                    content: data.text
                });
                bindMsgList();
            });
            
        };

        function msgTextFocus() {
            ui.boxMsgText.focus();
            setTimeout(function() {
                ui.boxMsgText.focus();
            }, 150);
        }
        //解决长按“发送”按钮，导致键盘关闭的问题；
        ui.footerRight.addEventListener('touchstart', function(event) {
            if(ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
                msgTextFocus();
                event.preventDefault();
            }
        });
        //解决长按“发送”按钮，导致键盘关闭的问题；
        ui.footerRight.addEventListener('touchmove', function(event) {
            if(ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
                msgTextFocus();
                event.preventDefault();
            }
        });

        ui.footerRight.addEventListener('release', function(event) {
            if(ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
                //showKeyboard();
                ui.boxMsgText.focus();
                setTimeout(function() {
                    ui.boxMsgText.focus();
                }, 150);
                //                          event.detail.gesture.preventDefault();
                send({                    
                    type: 'text',
//                  content: ui.boxMsgText.value
                    content: ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '<br/>')
                });
                ui.boxMsgText.value = '';
                $.trigger(ui.boxMsgText, 'input', null);
            } else if(ui.btnMsgType.classList.contains('mui-icon-mic')) {
                ui.btnMsgType.classList.add('mui-icon-compose');
                ui.btnMsgType.classList.remove('mui-icon-mic');
                ui.boxMsgText.style.display = 'none';
                ui.boxMsgSound.style.display = 'block';
                ui.boxMsgText.blur();
                document.body.focus();
            } else if(ui.btnMsgType.classList.contains('mui-icon-compose')) {
                ui.btnMsgType.classList.add('mui-icon-mic');
                ui.btnMsgType.classList.remove('mui-icon-compose');
                ui.boxMsgSound.style.display = 'none';
                ui.boxMsgText.style.display = 'block';
                //--
                //showKeyboard();
                ui.boxMsgText.focus();
                setTimeout(function() {
                    ui.boxMsgText.focus();
                }, 150);
            }
        }, false);
        ui.footerLeft.addEventListener('tap', function(event) {
            var btnArray = [{
                title: "拍照"
            }, {
                title: "从相册选择"
            }];
            plus.nativeUI.actionSheet({
                title: "选择照片",
                cancel: "取消",
                buttons: btnArray
            }, function(e) {
                var index = e.index;
                switch(index) {
                    case 0:
                        break;
                    case 1:
                        var cmr = plus.camera.getCamera();
                        cmr.captureImage(function(path) {
                            // 压缩图片  处理图片旋转问题
                            plus.zip.compressImage({
                                src: path,
                                dst: path,
                                overwrite: true,
                                format: 'jpg',
                                width: 'auto',
                                height: 'auto'
                            }, function (event) {
                                send({                                
                                    type: 'image',
                                    path: event.target
                                });
                            })
                            
                        }, function(err) {});
                        break;
                    case 2:
                        plus.gallery.pick(function(path) {
                            send({                                
                                type: 'image',
                                path: path
                            });
                        }, function(err) {}, null);
                        break;
                }
            });
        }, false);
        var setSoundAlertVisable = function(show) {
            if(show) {
                ui.boxSoundAlert.style.display = 'block';
                ui.boxSoundAlert.style.opacity = 1;
            } else {
                ui.boxSoundAlert.style.opacity = 0;
                //fadeOut 完成再真正隐藏
                setTimeout(function() {
                    ui.boxSoundAlert.style.display = 'none';
                }, 200);
            }
        };
        var recordCancel = false;
        var recorder = null;
        var audio_tips = document.getElementById("audio_tips");
        var startTimestamp = null;
        var stopTimestamp = null;
        var stopTimer = null;
        ui.boxMsgSound.addEventListener('hold', function(event) {
            recordCancel = false;
            if(stopTimer) clearTimeout(stopTimer);
            audio_tips.innerHTML = "手指上划，取消发送";
            ui.boxSoundAlert.classList.remove('rprogress-sigh');
            setSoundAlertVisable(true);
            recorder = plus.audio.getRecorder();
            if(recorder == null) {
                plus.nativeUI.toast("不能获取录音对象");
                return;
            }
            startTimestamp = (new Date()).getTime();
            recorder.record({
                filename: "_doc/audio/",
                format: 'amr'
            }, function(path) { 
                if(recordCancel) return;
                send({                    
                    type: 'sound',
                    path: path
                });
            }, function(e) {
                plus.nativeUI.toast("录音时出现异常: " + e.message);
            });
        }, false);
        ui.body.addEventListener('drag', function(event) {
            //console.log('drag');
            if(Math.abs(event.detail.deltaY) > 50) {
                if(!recordCancel) {
                    recordCancel = true;
                    if(!audio_tips.classList.contains("cancel")) {
                        audio_tips.classList.add("cancel");
                    }
                    audio_tips.innerHTML = "松开手指，取消发送";
                }
            } else {
                if(recordCancel) {
                    recordCancel = false;
                    if(audio_tips.classList.contains("cancel")) {
                        audio_tips.classList.remove("cancel");
                    }
                    audio_tips.innerHTML = "手指上划，取消发送";
                }
            }
        }, false);
        ui.boxMsgSound.addEventListener('release', function(event) {
            //console.log('release');
            if(audio_tips.classList.contains("cancel")) {
                audio_tips.classList.remove("cancel");
                audio_tips.innerHTML = "手指上划，取消发送";
            }
            //
            stopTimestamp = (new Date()).getTime();
            if(stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
                audio_tips.innerHTML = "录音时间太短";
                ui.boxSoundAlert.classList.add('rprogress-sigh');
                recordCancel = true;
                stopTimer = setTimeout(function() {
                    setSoundAlertVisable(false);
                }, 800);
            } else {
                setSoundAlertVisable(false);
            }
            recorder.stop();
        }, false);
        ui.boxMsgSound.addEventListener("touchstart", function(e) {
            //console.log("start....");
            e.preventDefault();
        });
        ui.boxMsgText.addEventListener('input', function(event) {
            ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
            ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
            ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
            ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
            ui.content.style.paddingBottom = ui.footer.style.height;
        });
        var focus = false;
        ui.boxMsgText.addEventListener('tap', function(event) {
            ui.boxMsgText.focus();
            setTimeout(function() {
                ui.boxMsgText.focus();
            }, 0);
            focus = true;
            setTimeout(function() {
                focus = false;
            }, 1000);
            event.detail.gesture.preventDefault();
        }, false);
        //点击消息列表，关闭键盘
        ui.areaMsgList.addEventListener('click', function(event) {
            if(!focus) {
                ui.boxMsgText.blur();
            }
        })
        
        // 显示日期
        function showDate (date) {
            if(!date) return '';
            return moment(date).format('MM月DD日  HH:mm');
        }

    }); 
}(mui, document));